﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Specialized;
using System.Net;
using System.Web;

namespace Anis.Twitter.Api {
    internal static class Utility {
        public static string HttpGet(string url, NameValueCollection queryString,string userID,string userPass) {
            string res = "";
            using(WebClient client = new WebClient()) {
                client.Encoding = Encoding.UTF8;

                client.Credentials = new NetworkCredential(userID, userPass);

                for(int i = 0; i < queryString.Keys.Count; i++) {
                    queryString[queryString.Keys[i]] = HttpUtility.UrlEncode(queryString[queryString.Keys[i]]);
                }
                client.QueryString = queryString;

                try {
                    res = client.DownloadString(url);
                } catch(WebException ex) {
                    if(ex.Message.Contains("401")) {
                        throw new WebException("パスワード、またはIDが間違ってるかも。", ex);
                    } else if(ex.Message.Contains("304")) {
                        throw new WebException("新しい情報はないのかも。", ex);
                    } else if(ex.Message.Contains("400")) {
                        throw new WebException("API の実行回数制限に引っ掛かったのかも。", ex);
                    } else if(ex.Message.Contains("403")) {
                        throw new WebException("権限が無いかも。", ex);
                    } else if(ex.Message.Contains("404")) {
                        throw new WebException("存在しない API を実行しようとしたり、存在しないユーザを引数で指定して API を実行しようとしたのかも。", ex);
                    } else if(ex.Message.Contains("500")) {
                        throw new WebException("Twitter 側で何らかの問題が発生しているのかも。", ex);
                    } else if(ex.Message.Contains("502")) {
                        throw new WebException("Twitter のサーバが止まっている、あるいはメンテ中かも。", ex);
                    } else if(ex.Message.Contains("503")) {
                        throw new WebException("Twitter のサーバの負荷が高すぎて、リクエストを裁き切れない状態になっているのかも。", ex);
                    }
                }
            }   
            return res;
        }

        public static string HttpPost(string url,NameValueCollection valus,string userID,string userPass) {
            string url_ = url + "?";
            byte[] res;
            using(WebClient client = new WebClient()) {
                client.Encoding = Encoding.UTF8;

                client.Credentials = new NetworkCredential(userID, userPass);

                foreach(string key in valus.Keys) {
                    url_ += key + "=" + HttpUtility.UrlEncode(valus[key]) + "&";
                }

                res = client.UploadData(url_, System.Text.Encoding.Default.GetBytes(""));
            }   
            return Encoding.UTF8.GetString(res);
        }

        public static DateTime ConvertDateTime(string dateTime) {
            return DateTime.ParseExact(dateTime, "ddd MMM d HH':'mm':'ss zzz yyyy", System.Globalization.DateTimeFormatInfo.InvariantInfo, System.Globalization.DateTimeStyles.None);
        }
        public static string ConvertDateTime(DateTime dateTime) {
            return dateTime.ToUniversalTime().ToString("ddd MMM dd HH':'mm':'ss '+0000' yyyy",System.Globalization.DateTimeFormatInfo.InvariantInfo);
        }
    }
}
