﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using System.Web;

namespace Anis.Twitter.Api {
    public class DirectMessage {
        internal static DirectMessage[] CreateDirectMessages(string xmlStr) {
            List<DirectMessage> r = new List<DirectMessage>();

            //string xmlStr = Utility.HttpGet(url, queryString, userID, userPass);

            XElement xEle = XElement.Parse(xmlStr);

            var directMessageElements = from element in xEle.Elements()
                                 where element.Name == "direct_message"
                                 select element;

            foreach(var directMessageElement in directMessageElements) {
                r.Add(new DirectMessage(directMessageElement));
            }

            return r.ToArray();
        }

        internal DirectMessage(XElement xElement) {
            foreach(XElement element in xElement.Elements()) {
                string value = HttpUtility.HtmlDecode(element.Value);
                switch(element.Name.LocalName) {
                case "id":
                    int id;
                    int.TryParse(value, out id);
                    this.ID = id;
                    break;
                case "text":
                    this.Text = value;
                    break;
                case "sender_id":
                    int sender_id;
                    int.TryParse(value, out sender_id);
                    this.SenderID = sender_id;
                    break;
                case "recipient_id":
                    int recipient_id;
                    int.TryParse(value, out recipient_id);
                    this.RecipientID = recipient_id;
                    break;
                case "created_at":
                    this.CreatedAt = Utility.ConvertDateTime(value);
                    break;
                case "sender_screen_name":
                    this.SenderScreenName = value;
                    break;
                case "recipient_screen_name":
                    this.RecipientScreenName = value;
                    break;
                }
            }
        }

        public int ID { set; get; }

        public string Text { set; get; }

        public int SenderID { set; get; }

        public int RecipientID { set; get; }

        public DateTime CreatedAt { set; get; }

        public string SenderScreenName { set; get; }

        public string RecipientScreenName { set; get; }
    }
}
