﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using System.Web;

namespace Anis.Twitter.Api {
    public class User {
        public User() { }

        internal static User[] CreateUsers(string xmlStr) {
            List<User> r = new List<User>();
            XElement xEle = XElement.Parse(xmlStr);

            var userElements = from f in xEle.Elements()
                    where f.Name == "user"
                    select f;

            foreach(var userElement in userElements) {
                r.Add(new User(userElement));
            }

            return r.ToArray();
        }

        internal User(string xmlStr)
            : this(XElement.Parse(xmlStr)) {
        }

        internal User(XElement xElement) {
            foreach(XElement ele in xElement.Elements()) {
                string value = HttpUtility.HtmlDecode(ele.Value);
                switch(ele.Name.LocalName) {
                case "id":
                    int id;
                    int.TryParse(value, out id);
                    this.Id = id;
                    break;
                case "name":
                    this.Name = value;
                    break;
                case "screen_name":
                    this.Screen_name = value;
                    break;
                case "location":
                    this.Location = value;
                    break;
                case "description":
                    this.Description = value;
                    break;
                case "profile_image_url":
                    this.Profile_image_url = value;
                    break;
                case "url":
                    this.Url = value;
                    break;
                case "protected":
                    bool protected_;
                    bool.TryParse(value, out protected_);
                    this.Protected = protected_;
                    break;
                case "followers_count":
                    int followers_count;
                    int.TryParse(value, out followers_count);
                    this.Followers_count = followers_count;
                    break;
                case "status":
                    this.Status = new Status(ele);
                    break;
                }
            }
        }

        //<id>00000000</id> 
        public int Id { set; get; }

        //<name></name> 
        public string Name { set; get; }

        //<screen_name></screen_name> 
        public string Screen_name { set; get; }

        //<description></description> 
        public string Description { set; get; }

        //<location></location> 
        public string Location { set; get; }
        
        //<profile_image_url>.jpg</profile_image_url> 
        public string Profile_image_url { set; get; }

        //<url></url> 
        public string Url { set; get; }

        //<protected>false</protected> 
        public bool Protected { set; get; }

        //<followers_count>0</followers_count> 
        public int Followers_count { set; get; }

        public Status Status { set; get; }
    }
}